#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
pygame.init()


class EP_Bar( pygame.sprite.Sprite ):
	def __init__( self, _width, _height, _pos_lefttop, _fg_colour, _bg_colour,
				  _remaining_ep_to_next_level ):

		self.fg_colour = _fg_colour
		self.bg_colour = _bg_colour
		
		self.image = pygame.Surface( ( _width, _height ) )
		self.image.fill( self.bg_colour )
		self.rect = self.image.get_rect()
		self.remaining_ep_to_next_level = _remaining_ep_to_next_level

		# How many EP are one pixel?
		self.one_ep = _width / float( self.remaining_ep_to_next_level ) # .e.g. 0.5

		self.width = _width
		self.height = _height
		

	def update( self, _current_ep, _pos_lefttop ):
		if _current_ep > 0:
			width = int (self.one_ep * _current_ep )
			self.ep_bar = pygame.Surface( ( width, self.height ) )
			self.ep_bar.fill( self.fg_colour )
			self.image.fill( self.bg_colour )
			self.image.blit( self.ep_bar, ( 0, 0 ) )
		else:
			self.image.fill( self.bg_colour )			
			
		self.rect.topleft = _pos_lefttop


	def renew( self, _new_ep_to_next_level ):
		self.remaining_ep_to_next_level = _new_ep_to_next_level

		# How many EP are one pixel?
		self.one_ep = self.width / float( self.remaining_ep_to_next_level ) # .e.g. 0.5
				
