#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
pygame.init()


class HP_Bar( pygame.sprite.Sprite ):
	def __init__( self, _width, _height, _pos_lefttop, _fg_colour, _bg_colour,
				  _max_hitpoints ):

		self.fg_colour = _fg_colour
		self.bg_colour = _bg_colour
		
		self.image = pygame.Surface( ( _width, _height ) )
		self.image.fill( self.bg_colour )
		self.rect = self.image.get_rect()
		self.max_hitpoints = _max_hitpoints

		# How many hitpoints are one pixel?
		self.one_hp = _width / float(_max_hitpoints) # .e.g. 0.5

		self.width = _width
		self.height = _height

		self.update( self.max_hitpoints, _pos_lefttop )

	def update( self, _current_hp, _pos_lefttop ):
		if _current_hp > 0:
			width = int (self.one_hp * _current_hp )
			self.hp_left_bar = pygame.Surface( ( width, self.height ) )
			self.hp_left_bar.fill( self.fg_colour )
			self.image.fill( self.bg_colour )
			self.image.blit( self.hp_left_bar, ( 0, 0 ) )
		else:
			self.image.fill( self.bg_colour )			
			
		self.rect.topleft = _pos_lefttop
