#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Modules
# Standard Python modules
import os
import os.path
import sqlite3

# Third party modules
import pygame

# Own modules
from config import config

pygame.init()


def load_image( _image_filename ):
	"""This function loads and image and returns an object of type
	pygame.Surface.

	"""

	image = pygame.image.load( os.path.join( config.GFX_PATH, _image_filename ) )
	image = image.convert()
	image.set_colorkey( config.BLACK )
	
	return image


def load_sound():
	pass


def load_music():
	pass


def sum_score( _score_player1 = 0, _score_player2 = 0 ):
	return _score_player1 + _score_player2


def get_highscores( _single_multi ):
	"""Returns the highscores.  Max 10 of them.

	"""
	db_conn = sqlite3.connect( config.DB_NAME )
	c = db_conn.cursor()

	if _single_multi == "single":
		c.execute( "SELECT * FROM highscore_single ORDER BY score DESC LIMIT 10" )
	else:
		c.execute( "SELECT * FROM highscore_multi ORDER BY score DESC LIMIT 10" )

	results = c.fetchall()
	db_conn.close()

	return results


def is_in_highscore( _score, _single_multi ):
	"""Returns True if the player has made it into the highscore, otherwise False.

	"""
	current_highscores = get_highscores( _single_multi )
	if len( current_highscores ) < 10:
		return True
		
	for current_highscore in current_highscores:
		if _score > current_highscore:
			return True

	return False


def insert_new_highscore( _name, _score, _single_multi ):
	"""

	"""
	db_conn = sqlite3.connect( config.DB_NAME )
	c = db_conn.cursor()

	if _single_multi == "single":
		string1 = "INSERT INTO highscore_single VALUES ( '%s', '%d' )" % ( _name, _score )
		c.execute( string1 )
		db_conn.commit()
	else:
		string1 = "INSERT INTO highscore_multi VALUES ( '%s', '%d' )" % ( _name, _score )
		c.execute( string1 )
		db_conn.commit()

	db_conn.close()
