#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Modules

# Third party Python modules
import pygame

# Import own modules
from modules import helpers

pygame.init()

allowed_area = pygame.Rect( 0, 59, 1024, 650 )


LEVELS = {
	21: {
		"_image": "Rootkit.png",
		"_direction": 90,
		"_speed": 1,
		"_turn_speed": 5,
		"_allowed_area": allowed_area,
		"_max_hitpoints": 300,
		"_current_hitpoints": 300,
		"_projectile_speed": 10,
		"_projectile_image": "Rootkit_Projectile.png",
		"_projectile_damage": [50, 100],
		"_shooting_interval": 3,
		"_kill_score": 300,
		"_additional_dodging_amount": 15,
		"_ep_on_projectile_hit": 100
	},
	22: {
		"_image": "Rootkit.png",
		"_direction": 90,
		"_speed": 1,
		"_turn_speed": 5,
		"_allowed_area": allowed_area,
		"_max_hitpoints": 400,
		"_current_hitpoints": 400,
		"_projectile_speed": 10,
		"_projectile_image": "Rootkit_Projectile.png",
		"_projectile_damage": [100, 150],
		"_shooting_interval": 3,
		"_kill_score": 400,
		"_additional_dodging_amount": 15,
		"_ep_on_projectile_hit": 150
	},
	23: {
		"_image": "Rootkit.png",
		"_direction": 90,
		"_speed": 1,
		"_turn_speed": 5,
		"_allowed_area": allowed_area,
		"_max_hitpoints": 500,
		"_current_hitpoints": 500,
		"_projectile_speed": 10,
		"_projectile_image": "Rootkit_Projectile.png",
		"_projectile_damage": [150, 200],
		"_shooting_interval": 3,
		"_kill_score": 500,
		"_additional_dodging_amount": 15,
		"_ep_on_projectile_hit": 200
	},
	24: {
		"_image": "Rootkit.png",
		"_direction": 90,
		"_speed": 1,
		"_turn_speed": 5,
		"_allowed_area": allowed_area,
		"_max_hitpoints": 600,
		"_current_hitpoints": 600,
		"_projectile_speed": 10,
		"_projectile_image": "Rootkit_Projectile.png",
		"_projectile_damage": [200, 250],
		"_shooting_interval": 3,
		"_kill_score": 600,
		"_additional_dodging_amount": 15,
		"_ep_on_projectile_hit": 250
	},
	25: {
		"_image": "Rootkit.png",
		"_direction": 90,
		"_speed": 1,
		"_turn_speed": 5,
		"_allowed_area": allowed_area,
		"_max_hitpoints": 700,
		"_current_hitpoints": 700,
		"_projectile_speed": 10,
		"_projectile_image": "Rootkit_Projectile.png",
		"_projectile_damage": [250, 300],
		"_shooting_interval": 3,
		"_kill_score": 700,
		"_additional_dodging_amount": 15,
		"_ep_on_projectile_hit": 300
	}
}			
